# Allowing lightning bolts to power wires
execute as @e[type=minecraft:lightning_bolt] at @s if block ~ ~-1 ~ minecraft:lightning_rod run function copperwire:wire_summon
execute as @e[type=minecraft:lightning_bolt] at @s if block ~ ~ ~ minecraft:lightning_rod run function copperwire:wire_summon

# Looking at activation, deactivation, and alignment
execute as @e[type=player,tag=!created_chain] anchored eyes at @s if block ^ ^ ^1 chain run function copperwire:wire_summon
execute as @e[type=player,tag=!created_chain] anchored eyes at @s if block ^ ^ ^2 chain run function copperwire:wire_summon
execute as @e[type=player,tag=!created_chain] anchored eyes at @s if block ^ ^ ^3 chain run function copperwire:wire_summon
execute as @e[type=player,tag=!created_chain] anchored eyes at @s if block ^ ^ ^4 chain run function copperwire:wire_summon
execute as @e[type=player,tag=created_chain] anchored eyes at @s unless block ^ ^ ^1 chain unless block ^ ^ ^2 chain unless block ^ ^ ^3 chain unless block ^ ^ ^4 chain run tag @s remove created_chain
execute as @e[type=marker,tag=transformer_chain,tag=!aligned] at @s if block ~ ~ ~ chain align xyz run tp ~.5 ~.45 ~.5
execute as @e[type=marker,tag=transformer_chain,tag=!aligned] at @s if block ~ ~ ~ chain run tag @s add aligned
execute as @e[type=player,tag=!created_heavy_core] anchored eyes at @s if block ^ ^ ^1 heavy_core run function copperwire:wire_summon
execute as @e[type=player,tag=!created_heavy_core] anchored eyes at @s if block ^ ^ ^2 heavy_core run function copperwire:wire_summon
execute as @e[type=player,tag=!created_heavy_core] anchored eyes at @s if block ^ ^ ^3 heavy_core run function copperwire:wire_summon
execute as @e[type=player,tag=!created_heavy_core] anchored eyes at @s if block ^ ^ ^4 heavy_core run function copperwire:wire_summon
execute as @e[type=player,tag=created_heavy_core] anchored eyes at @s unless block ^ ^ ^1 heavy_core unless block ^ ^ ^2 heavy_core unless block ^ ^ ^3 heavy_core unless block ^ ^ ^4 heavy_core run tag @s remove created_heavy_core
execute as @e[type=text_display,tag=capacitor_text_display,tag=!aligned] at @s if block ~ ~ ~ heavy_core align xyz run tp ~.5 ~.45 ~.5
execute as @e[type=text_display,tag=capacitor_text_display,tag=!aligned] at @s if block ~ ~ ~ heavy_core run tag @s add aligned

# Kill commands
execute as @e[type=marker,tag=passthrough_wire_block] at @s unless block ~ ~ ~ #copperwire:chiseled_coppers run function copperwire:block_moved
execute as @e[type=marker,tag=split_wire_block] at @s unless block ~ ~ ~ #copperwire:copper_grates run function copperwire:block_moved
execute as @e[type=marker,tag=transformer_chain] at @s unless block ~ ~ ~ chain run function copperwire:block_moved
execute as @e[type=text_display,tag=capacitor_text_display] at @s unless block ~ ~ ~ heavy_core run function copperwire:block_moved
execute as @e[type=marker,tag=copper_wire,tag=!passthrough_wire_block,tag=!split_wire_block,tag=!transformer_chain] at @s unless block ~ ~ ~ lightning_rod[powered=true] run kill @s
execute as @e[type=marker,tag=copper_wire,tag=!original] at @s if entity @e[type=marker,tag=copper_wire,tag=original,distance=...001] run kill @s
execute as @e[type=marker,tag=copper_wire,tag=!original] at @s unless entity @e[type=marker,tag=copper_wire,tag=original,distance=...001] run tag @s add original
execute as @e[type=text_display,tag=capacitor_text_display,tag=!original] at @s if entity @e[type=text_display,tag=capacitor_text_display,tag=original,distance=...001] run kill @s
execute as @e[type=text_display,tag=capacitor_text_display,tag=!original] at @s unless entity @e[type=text_display,tag=capacitor_text_display,tag=original,distance=...001] run tag @s add original

# Non-looking at activations
execute as @e[type=marker,tag=copper_wire,tag=!summoned] at @s if block ~ ~ ~ lightning_rod[powered=true] run function copperwire:wire_summon
execute as @e[type=marker,tag=copper_wire,tag=summoned] at @s if block ~ ~ ~ lightning_rod run function copperwire:wire_resummon
execute as @e[type=marker,tag=transformer_chain,tag=!summoned] at @s run function copperwire:wire_summon
execute as @e[type=marker,tag=transformer_chain,tag=summoned] at @s run function copperwire:wire_resummon
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ #copperwire:grates_and_chiseled run function copperwire:wire_summon
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ #copperwire:grates_and_chiseled run function copperwire:wire_resummon


# Power off
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=east,powered=true,waterlogged=false] unless block ~-1 ~ ~ lightning_rod[facing=east,powered=true] unless block ~-1 ~ ~ chain[axis=x] unless block ~-1 ~ ~ #copperwire:grates_and_chiseled unless entity @e[type=lightning_bolt,distance=..1] run setblock ~ ~ ~ lightning_rod[facing=east,powered=false]
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=west,powered=true,waterlogged=false] unless block ~1 ~ ~ lightning_rod[facing=west,powered=true] unless block ~1 ~ ~ chain[axis=x] unless block ~1 ~ ~ #copperwire:grates_and_chiseled unless entity @e[type=lightning_bolt,distance=..1] run setblock ~ ~ ~ lightning_rod[facing=west,powered=false]
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=north,powered=true,waterlogged=false] unless block ~ ~ ~1 lightning_rod[facing=north,powered=true] unless block ~ ~ ~1 chain[axis=z] unless block ~ ~ ~1 #copperwire:grates_and_chiseled unless entity @e[type=lightning_bolt,distance=..1] run setblock ~ ~ ~ lightning_rod[facing=north,powered=false]
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=south,powered=true,waterlogged=false] unless block ~ ~ ~-1 lightning_rod[facing=south,powered=true] unless block ~ ~ ~-1 chain[axis=z] unless block ~ ~ ~-1 #copperwire:grates_and_chiseled unless entity @e[type=lightning_bolt,distance=..1] run setblock ~ ~ ~ lightning_rod[facing=south,powered=false]
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=up,powered=true,waterlogged=false] unless block ~ ~-1 ~ lightning_rod[facing=up,powered=true] unless block ~ ~-1 ~ chain[axis=y] unless block ~ ~-1 ~ #copperwire:grates_and_chiseled unless entity @e[type=lightning_bolt,distance=..1] run setblock ~ ~ ~ lightning_rod[facing=up,powered=false]
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=down,powered=true,waterlogged=false] unless block ~ ~1 ~ lightning_rod[facing=down,powered=true] unless block ~ ~1 ~ chain[axis=y] unless block ~ ~1 ~ #copperwire:grates_and_chiseled unless entity @e[type=lightning_bolt,distance=..1] unless block ~ ~1 ~ heavy_core run setblock ~ ~ ~ lightning_rod[facing=down,powered=false]

# Waterlogged power off
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=east,powered=true,waterlogged=true] unless block ~-1 ~ ~ lightning_rod[facing=east,powered=true] unless block ~-1 ~ ~ chain[axis=x] unless block ~-1 ~ ~ #copperwire:grates_and_chiseled unless entity @e[type=lightning_bolt,distance=..1] run setblock ~ ~ ~ lightning_rod[facing=east,powered=false,waterlogged=true]
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=west,powered=true,waterlogged=true] unless block ~1 ~ ~ lightning_rod[facing=west,powered=true] unless block ~1 ~ ~ chain[axis=x] unless block ~1 ~ ~ #copperwire:grates_and_chiseled unless entity @e[type=lightning_bolt,distance=..1] run setblock ~ ~ ~ lightning_rod[facing=west,powered=false,waterlogged=true]
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=north,powered=true,waterlogged=true] unless block ~ ~ ~1 lightning_rod[facing=north,powered=true] unless block ~ ~ ~1 chain[axis=z] unless block ~ ~ ~1 #copperwire:grates_and_chiseled unless entity @e[type=lightning_bolt,distance=..1] run setblock ~ ~ ~ lightning_rod[facing=north,powered=false,waterlogged=true]
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=south,powered=true,waterlogged=true] unless block ~ ~ ~-1 lightning_rod[facing=south,powered=true] unless block ~ ~ ~-1 chain[axis=z] unless block ~ ~ ~-1 #copperwire:grates_and_chiseled unless entity @e[type=lightning_bolt,distance=..1] run setblock ~ ~ ~ lightning_rod[facing=south,powered=false,waterlogged=true]
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=up,powered=true,waterlogged=true] unless block ~ ~-1 ~ lightning_rod[facing=up,powered=true] unless block ~ ~-1 ~ chain[axis=y] unless block ~ ~-1 ~ #copperwire:grates_and_chiseled unless entity @e[type=lightning_bolt,distance=..1] run setblock ~ ~ ~ lightning_rod[facing=up,powered=false,waterlogged=true]
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=down,powered=true,waterlogged=true] unless block ~ ~1 ~ lightning_rod[facing=down,powered=true] unless block ~ ~1 ~ chain[axis=y] unless block ~ ~1 ~ #copperwire:grates_and_chiseled unless entity @e[type=lightning_bolt,distance=..1] unless block ~ ~1 ~ heavy_core run setblock ~ ~ ~ lightning_rod[facing=down,powered=false,waterlogged=true]

# Power on
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=east,powered=false,waterlogged=false] if block ~-1 ~ ~ lightning_rod[facing=east,powered=true] run setblock ~ ~ ~ lightning_rod[facing=east,powered=true]
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=west,powered=false,waterlogged=false] if block ~1 ~ ~ lightning_rod[facing=west,powered=true] run setblock ~ ~ ~ lightning_rod[facing=west,powered=true]
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=north,powered=false,waterlogged=false] if block ~ ~ ~1 lightning_rod[facing=north,powered=true] run setblock ~ ~ ~ lightning_rod[facing=north,powered=true]
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=south,powered=false,waterlogged=false] if block ~ ~ ~-1 lightning_rod[facing=south,powered=true] run setblock ~ ~ ~ lightning_rod[facing=south,powered=true]
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=up,powered=false,waterlogged=false] if block ~ ~-1 ~ lightning_rod[facing=up,powered=true] run setblock ~ ~ ~ lightning_rod[facing=up,powered=true]
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=down,powered=false,waterlogged=false] if block ~ ~1 ~ lightning_rod[facing=down,powered=true] run setblock ~ ~ ~ lightning_rod[facing=down,powered=true]

# Waterlogged power on
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=east,powered=false,waterlogged=true] if block ~-1 ~ ~ lightning_rod[facing=east,powered=true] run setblock ~ ~ ~ lightning_rod[facing=east,powered=true,waterlogged=true]
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=west,powered=false,waterlogged=true] if block ~1 ~ ~ lightning_rod[facing=west,powered=true] run setblock ~ ~ ~ lightning_rod[facing=west,powered=true,waterlogged=true]
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=north,powered=false,waterlogged=true] if block ~ ~ ~1 lightning_rod[facing=north,powered=true] run setblock ~ ~ ~ lightning_rod[facing=north,powered=true,waterlogged=true]
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=south,powered=false,waterlogged=true] if block ~ ~ ~-1 lightning_rod[facing=south,powered=true] run setblock ~ ~ ~ lightning_rod[facing=south,powered=true,waterlogged=true]
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=up,powered=false,waterlogged=true] if block ~ ~-1 ~ lightning_rod[facing=up,powered=true] run setblock ~ ~ ~ lightning_rod[facing=up,powered=true,waterlogged=true]
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=down,powered=false,waterlogged=true] if block ~ ~1 ~ lightning_rod[facing=down,powered=true] run setblock ~ ~ ~ lightning_rod[facing=down,powered=true,waterlogged=true]

# Particles
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=east,powered=true] if block ~1 ~ ~ air run particle electric_spark ~.6 ~ ~ 0.01 0.01 0.01 .1 1
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=west,powered=true] if block ~-1 ~ ~ air run particle electric_spark ~-.6 ~ ~ 0.01 0.01 0.01 .1 1
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=north,powered=true] if block ~ ~ ~-1 air run particle electric_spark ~ ~ ~-.6 0.01 0.01 0.01 .1 1
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=south,powered=true] if block ~ ~ ~1 air run particle electric_spark ~ ~ ~.6 0.01 0.01 0.01 .1 1
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=up,powered=true] if block ~ ~1 ~ air run particle electric_spark ~ ~.6 ~ 0.01 0.01 0.01 .1 1
execute as @e[type=marker,tag=copper_wire] at @s if block ~ ~ ~ lightning_rod[facing=down,powered=true] if block ~ ~-1 ~ air run particle electric_spark ~ ~-.6 ~ 0.01 0.01 0.01 .1 1


# Damaging players/mobs from shock damage
execute as @e at @s if block ~ ~ ~ minecraft:lightning_rod[powered=true] run damage @s 1 minecraft:lightning_bolt
execute as @e at @s if block ~.5 ~ ~ minecraft:lightning_rod[powered=true,facing=west] run damage @s 1 minecraft:lightning_bolt
execute as @e at @s if block ~-.5 ~ ~ minecraft:lightning_rod[powered=true,facing=east] run damage @s 1 minecraft:lightning_bolt
execute as @e at @s if block ~ ~ ~.5 minecraft:lightning_rod[powered=true,facing=north] run damage @s 1 minecraft:lightning_bolt
execute as @e at @s if block ~ ~ ~-.5 minecraft:lightning_rod[powered=true,facing=south] run damage @s 1 minecraft:lightning_bolt
execute as @e at @s if block ~ ~-.5 ~ minecraft:lightning_rod[powered=true,facing=up] run damage @s 1 minecraft:lightning_bolt
execute as @e at @s if block ~ ~.5 ~ minecraft:lightning_rod[powered=true,facing=down] run damage @s 1 minecraft:lightning_bolt

# Block functions 
execute as @e[type=marker,tag=split_wire_block] at @s if block ~ ~ ~ #copperwire:copper_grates run function copperwire:split_wire
execute as @e[type=marker,tag=passthrough_wire_block] at @s if block ~ ~ ~ #copperwire:chiseled_coppers run function copperwire:passthrough_wire
execute as @e[type=marker,tag=transformer_chain] at @s if block ~ ~ ~ chain run function copperwire:transformer
execute as @e[type=text_display,tag=capacitor_text_display] at @s if block ~ ~ ~ heavy_core run function copperwire:capacitor