# Determining number of inputs and outputs
execute as @s at @s run scoreboard players reset @s input_power
execute as @s at @s if block ~-1 ~ ~ lightning_rod[facing=east,powered=true] run scoreboard players add @s input_power 1
execute as @s at @s if block ~1 ~ ~ lightning_rod[facing=west,powered=true] run scoreboard players add @s input_power 1
execute as @s at @s if block ~ ~ ~-1 lightning_rod[facing=south,powered=true] run scoreboard players add @s input_power 1
execute as @s at @s if block ~ ~ ~1 lightning_rod[facing=north,powered=true] run scoreboard players add @s input_power 1
execute as @s at @s if block ~ ~-1 ~ lightning_rod[facing=up,powered=true] run scoreboard players add @s input_power 1
execute as @s at @s if block ~ ~1 ~ lightning_rod[facing=down,powered=true] run scoreboard players add @s input_power 1
execute as @s at @s if block ~1 ~ ~ lightning_rod[facing=east] run scoreboard players remove @s input_power 1
execute as @s at @s if block ~-1 ~ ~ lightning_rod[facing=west] run scoreboard players remove @s input_power 1
execute as @s at @s if block ~ ~ ~1 lightning_rod[facing=south] run scoreboard players remove @s input_power 1
execute as @s at @s if block ~ ~ ~-1 lightning_rod[facing=north] run scoreboard players remove @s input_power 1
execute as @s at @s if block ~ ~1 ~ lightning_rod[facing=up] run scoreboard players remove @s input_power 1
execute as @s at @s if block ~ ~-1 ~ lightning_rod[facing=down] run scoreboard players remove @s input_power 1

# Setting and updating a second score for comparison
execute as @s at @s run scoreboard players operation @s Input_Power = @s input_power
execute as @s at @s positioned ~ ~1 ~ if score @n[tag=capacitor_text_display,distance=...001] Capacitor_Charge matches 1.. if score @s Input_Power matches -1 run scoreboard players add @s Input_Power 1
execute as @s at @s positioned ~ ~1 ~ if score @n[tag=capacitor_text_display,distance=...001] Capacitor_Charge matches 2.. if score @s Input_Power matches -2 run scoreboard players add @s Input_Power 2
execute as @s at @s positioned ~ ~1 ~ if score @n[tag=capacitor_text_display,distance=...001] Capacitor_Charge matches 3.. if score @s Input_Power matches -3 run scoreboard players add @s Input_Power 3
execute as @s at @s positioned ~ ~1 ~ if score @n[tag=capacitor_text_display,distance=...001] Capacitor_Charge matches 4.. if score @s Input_Power matches -4 run scoreboard players add @s Input_Power 4
execute as @s at @s positioned ~ ~1 ~ if score @n[tag=capacitor_text_display,distance=...001] Capacitor_Charge matches 5.. if score @s Input_Power matches -5 run scoreboard players add @s Input_Power 5
execute as @s at @s positioned ~ ~1 ~ if score @n[tag=capacitor_text_display,distance=...001] Capacitor_Charge matches 0.. if score @s Input_Power matches 1 run scoreboard players remove @s Input_Power 1
execute as @s at @s positioned ~ ~1 ~ if score @n[tag=capacitor_text_display,distance=...001] Capacitor_Charge matches 0.. if score @s Input_Power matches 2 run scoreboard players remove @s Input_Power 2
execute as @s at @s positioned ~ ~1 ~ if score @n[tag=capacitor_text_display,distance=...001] Capacitor_Charge matches 0.. if score @s Input_Power matches 3 run scoreboard players remove @s Input_Power 3
execute as @s at @s positioned ~ ~1 ~ if score @n[tag=capacitor_text_display,distance=...001] Capacitor_Charge matches 0.. if score @s Input_Power matches 4 run scoreboard players remove @s Input_Power 4
execute as @s at @s positioned ~ ~1 ~ if score @n[tag=capacitor_text_display,distance=...001] Capacitor_Charge matches 0.. if score @s Input_Power matches 5 run scoreboard players remove @s Input_Power 5

# Tagging
execute as @s if score @s Input_Power matches ..-1 run tag @s remove powered
execute as @s if score @s Input_Power matches 0.. run tag @s add powered

# Power off
execute as @s[tag=!powered] at @s if block ~1 ~ ~ lightning_rod[facing=east,powered=true,waterlogged=false] run setblock ~1 ~ ~ lightning_rod[facing=east,powered=false]
execute as @s[tag=!powered] at @s if block ~-1 ~ ~ lightning_rod[facing=west,powered=true,waterlogged=false] run setblock ~-1 ~ ~ lightning_rod[facing=west,powered=false]
execute as @s[tag=!powered] at @s if block ~ ~ ~1 lightning_rod[facing=south,powered=true,waterlogged=false] run setblock ~ ~ ~1 lightning_rod[facing=south,powered=false]
execute as @s[tag=!powered] at @s if block ~ ~ ~-1 lightning_rod[facing=north,powered=true,waterlogged=false] run setblock ~ ~ ~-1 lightning_rod[facing=north,powered=false]
execute as @s[tag=!powered] at @s if block ~ ~1 ~ lightning_rod[facing=up,powered=true,waterlogged=false] run setblock ~ ~1 ~ lightning_rod[facing=up,powered=false]
execute as @s[tag=!powered] at @s if block ~ ~-1 ~ lightning_rod[facing=down,powered=true,waterlogged=false] run setblock ~ ~-1 ~ lightning_rod[facing=down,powered=false]

# Power on
execute as @s[tag=powered] at @s if block ~1 ~ ~ lightning_rod[facing=east,powered=false,waterlogged=false] run setblock ~1 ~ ~ lightning_rod[facing=east,powered=true]
execute as @s[tag=powered] at @s if block ~-1 ~ ~ lightning_rod[facing=west,powered=false,waterlogged=false] run setblock ~-1 ~ ~ lightning_rod[facing=west,powered=true]
execute as @s[tag=powered] at @s if block ~ ~ ~1 lightning_rod[facing=south,powered=false,waterlogged=false] run setblock ~ ~ ~1 lightning_rod[facing=south,powered=true]
execute as @s[tag=powered] at @s if block ~ ~ ~-1 lightning_rod[facing=north,powered=false,waterlogged=false] run setblock ~ ~ ~-1 lightning_rod[facing=north,powered=true]
execute as @s[tag=powered] at @s if block ~ ~1 ~ lightning_rod[facing=up,powered=false,waterlogged=false] run setblock ~ ~1 ~ lightning_rod[facing=up,powered=true]
execute as @s[tag=powered] at @s if block ~ ~-1 ~ lightning_rod[facing=down,powered=false,waterlogged=false] run setblock ~ ~-1 ~ lightning_rod[facing=down,powered=true]

# Power off waterlogged
execute as @s[tag=powered] at @s if block ~1 ~ ~ lightning_rod[facing=east,powered=false,waterlogged=true] run setblock ~1 ~ ~ lightning_rod[facing=east,powered=true,waterlogged=true]
execute as @s[tag=powered] at @s if block ~-1 ~ ~ lightning_rod[facing=west,powered=false,waterlogged=true] run setblock ~-1 ~ ~ lightning_rod[facing=west,powered=true,waterlogged=true]
execute as @s[tag=powered] at @s if block ~ ~ ~1 lightning_rod[facing=south,powered=false,waterlogged=true] run setblock ~ ~ ~1 lightning_rod[facing=south,powered=true,waterlogged=true]
execute as @s[tag=powered] at @s if block ~ ~ ~-1 lightning_rod[facing=north,powered=false,waterlogged=true] run setblock ~ ~ ~-1 lightning_rod[facing=north,powered=true,waterlogged=true]
execute as @s[tag=powered] at @s if block ~ ~1 ~ lightning_rod[facing=up,powered=false,waterlogged=true] run setblock ~ ~1 ~ lightning_rod[facing=up,powered=true,waterlogged=true]
execute as @s[tag=powered] at @s if block ~ ~-1 ~ lightning_rod[facing=down,powered=false,waterlogged=true] run setblock ~ ~-1 ~ lightning_rod[facing=down,powered=true,waterlogged=true]

# Power on waterlogged
execute as @s[tag=!powered] at @s if block ~1 ~ ~ lightning_rod[facing=east,powered=true,waterlogged=true] run setblock ~1 ~ ~ lightning_rod[facing=east,powered=false,waterlogged=true]
execute as @s[tag=!powered] at @s if block ~-1 ~ ~ lightning_rod[facing=west,powered=true,waterlogged=true] run setblock ~-1 ~ ~ lightning_rod[facing=west,powered=false,waterlogged=true]
execute as @s[tag=!powered] at @s if block ~ ~ ~1 lightning_rod[facing=south,powered=true,waterlogged=true] run setblock ~ ~ ~1 lightning_rod[facing=south,powered=false,waterlogged=true]
execute as @s[tag=!powered] at @s if block ~ ~ ~-1 lightning_rod[facing=north,powered=true,waterlogged=true] run setblock ~ ~ ~-1 lightning_rod[facing=north,powered=false,waterlogged=true]
execute as @s[tag=!powered] at @s if block ~ ~1 ~ lightning_rod[facing=up,powered=true,waterlogged=true] run setblock ~ ~1 ~ lightning_rod[facing=up,powered=false,waterlogged=true]
execute as @s[tag=!powered] at @s if block ~ ~-1 ~ lightning_rod[facing=down,powered=true,waterlogged=true] run setblock ~ ~-1 ~ lightning_rod[facing=down,powered=false,waterlogged=true]

# Particles 
execute as @s at @s if score @s input_power < @s Input_Power if score @s input_power matches ..-5 run particle wax_on ~ ~ ~ 0.15 0.15 0.15 1 1
execute as @s at @s if score @s input_power < @s Input_Power if score @s input_power matches ..-4 run particle wax_on ~ ~ ~ 0.15 0.15 0.15 1 1
execute as @s at @s if score @s input_power < @s Input_Power if score @s input_power matches ..-3 run particle wax_on ~ ~ ~ 0.15 0.15 0.15 1 1
execute as @s at @s if score @s input_power < @s Input_Power if score @s input_power matches ..-2 run particle wax_on ~ ~ ~ 0.15 0.15 0.15 1 1
execute as @s at @s if score @s input_power < @s Input_Power if score @s input_power matches ..-1 run particle wax_on ~ ~ ~ 0.15 0.15 0.15 1 1

execute as @s at @s if score @s input_power = @s Input_Power if score @s input_power matches 1.. run particle wax_off ~ ~ ~ 0.15 0.15 0.15 1 1
execute as @s at @s if score @s input_power = @s Input_Power if score @s input_power matches 2.. run particle wax_off ~ ~ ~ 0.15 0.15 0.15 1 1
execute as @s at @s if score @s input_power = @s Input_Power if score @s input_power matches 3.. run particle wax_off ~ ~ ~ 0.15 0.15 0.15 1 1
execute as @s at @s if score @s input_power = @s Input_Power if score @s input_power matches 4.. run particle wax_off ~ ~ ~ 0.15 0.15 0.15 1 1
execute as @s at @s if score @s input_power = @s Input_Power if score @s input_power matches 5.. run particle wax_off ~ ~ ~ 0.15 0.15 0.15 1 1

