tag @s[type=!player] add summoned
tag @s[type=player] add created_chain
tag @s[type=player] add created_heavy_core

# Lightning activation
execute as @s[type=lightning_bolt] at @s if block ~ ~-1 ~ minecraft:lightning_rod align xyz run summon marker ~.5 ~-.55 ~.5 {Tags:["copper_wire"]}
execute as @s[type=lightning_bolt] at @s if block ~ ~ ~ minecraft:lightning_rod align xyz run summon marker ~.5 ~.45 ~.5 {Tags:["copper_wire"]}

# Looking activation
execute as @s[type=player] anchored eyes at @s if block ^ ^ ^1 chain run summon marker ^ ^ ^1 {Tags:["copper_wire","transformer_chain"]}
execute as @s[type=player] anchored eyes at @s if block ^ ^ ^2 chain run summon marker ^ ^ ^2 {Tags:["copper_wire","transformer_chain"]}
execute as @s[type=player] anchored eyes at @s if block ^ ^ ^3 chain run summon marker ^ ^ ^3 {Tags:["copper_wire","transformer_chain"]}
execute as @s[type=player] anchored eyes at @s if block ^ ^ ^4 chain run summon marker ^ ^ ^4 {Tags:["copper_wire","transformer_chain"]}
execute as @s[type=player] anchored eyes at @s if block ^ ^ ^1 heavy_core run summon text_display ^ ^ ^1 {Tags:["capacitor_text_display"],billboard:"center",text:'{"color":"light_purple","score":{"name":"@s","objective":"Capacitor_Charge"}}',transformation:{left_rotation:[0f,0f,0f,1f],right_rotation:[0f,0f,0f,1f],translation:[0f,.25f,0f],scale:[1f,1f,1f]}}
execute as @s[type=player] anchored eyes at @s if block ^ ^ ^2 heavy_core run summon text_display ^ ^ ^2 {Tags:["capacitor_text_display"],billboard:"center",text:'{"color":"light_purple","score":{"name":"@s","objective":"Capacitor_Charge"}}',transformation:{left_rotation:[0f,0f,0f,1f],right_rotation:[0f,0f,0f,1f],translation:[0f,.25f,0f],scale:[1f,1f,1f]}}
execute as @s[type=player] anchored eyes at @s if block ^ ^ ^3 heavy_core run summon text_display ^ ^ ^3 {Tags:["capacitor_text_display"],billboard:"center",text:'{"color":"light_purple","score":{"name":"@s","objective":"Capacitor_Charge"}}',transformation:{left_rotation:[0f,0f,0f,1f],right_rotation:[0f,0f,0f,1f],translation:[0f,.25f,0f],scale:[1f,1f,1f]}}
execute as @s[type=player] anchored eyes at @s if block ^ ^ ^4 heavy_core run summon text_display ^ ^ ^4 {Tags:["capacitor_text_display"],billboard:"center",text:'{"color":"light_purple","score":{"name":"@s","objective":"Capacitor_Charge"}}',transformation:{left_rotation:[0f,0f,0f,1f],right_rotation:[0f,0f,0f,1f],translation:[0f,.25f,0f],scale:[1f,1f,1f]}}

# Wire to Wire activation
execute as @s[type=marker] at @s if block ~ ~ ~ lightning_rod[facing=east] if block ~1 ~ ~ lightning_rod[facing=east,powered=false] run summon marker ~1 ~ ~ {Tags:["copper_wire"]}
execute as @s[type=marker] at @s if block ~ ~ ~ lightning_rod[facing=west] if block ~-1 ~ ~ lightning_rod[facing=west,powered=false] run summon marker ~-1 ~ ~ {Tags:["copper_wire"]}
execute as @s[type=marker] at @s if block ~ ~ ~ lightning_rod[facing=north] if block ~ ~ ~-1 lightning_rod[facing=north,powered=false] run summon marker ~ ~ ~-1 {Tags:["copper_wire"]}
execute as @s[type=marker] at @s if block ~ ~ ~ lightning_rod[facing=south] if block ~ ~ ~1 lightning_rod[facing=south,powered=false] run summon marker ~ ~ ~1 {Tags:["copper_wire"]}
execute as @s[type=marker] at @s if block ~ ~ ~ lightning_rod[facing=up] if block ~ ~1 ~ lightning_rod[facing=up,powered=false] run summon marker ~ ~1 ~ {Tags:["copper_wire"]}
execute as @s[type=marker] at @s if block ~ ~ ~ lightning_rod[facing=down] if block ~ ~-1 ~ lightning_rod[facing=down,powered=false] run summon marker ~ ~-1 ~ {Tags:["copper_wire"]}

execute as @s[type=marker] at @s if block ~ ~ ~ lightning_rod[facing=east] if block ~1 ~ ~ #copperwire:copper_grates run summon marker ~1 ~ ~ {Tags:["copper_wire","split_wire_block"]}
execute as @s[type=marker] at @s if block ~ ~ ~ lightning_rod[facing=west] if block ~-1 ~ ~ #copperwire:copper_grates run summon marker ~-1 ~ ~ {Tags:["copper_wire","split_wire_block"]}
execute as @s[type=marker] at @s if block ~ ~ ~ lightning_rod[facing=north] if block ~ ~ ~-1 #copperwire:copper_grates run summon marker ~ ~ ~-1 {Tags:["copper_wire","split_wire_block"]}
execute as @s[type=marker] at @s if block ~ ~ ~ lightning_rod[facing=south] if block ~ ~ ~1 #copperwire:copper_grates run summon marker ~ ~ ~1 {Tags:["copper_wire","split_wire_block"]}
execute as @s[type=marker] at @s if block ~ ~ ~ lightning_rod[facing=up] if block ~ ~1 ~ #copperwire:copper_grates run summon marker ~ ~1 ~ {Tags:["copper_wire","split_wire_block"]}
execute as @s[type=marker] at @s if block ~ ~ ~ lightning_rod[facing=down] if block ~ ~-1 ~ #copperwire:copper_grates run summon marker ~ ~-1 ~ {Tags:["copper_wire","split_wire_block"]}
execute as @s[type=marker] at @s if block ~ ~ ~ lightning_rod[facing=east] if block ~1 ~ ~ #copperwire:chiseled_coppers run summon marker ~1 ~ ~ {Tags:["copper_wire","passthrough_wire_block"]}
execute as @s[type=marker] at @s if block ~ ~ ~ lightning_rod[facing=west] if block ~-1 ~ ~ #copperwire:chiseled_coppers run summon marker ~-1 ~ ~ {Tags:["copper_wire","passthrough_wire_block"]}
execute as @s[type=marker] at @s if block ~ ~ ~ lightning_rod[facing=north] if block ~ ~ ~-1 #copperwire:chiseled_coppers run summon marker ~ ~ ~-1 {Tags:["copper_wire","passthrough_wire_block"]}
execute as @s[type=marker] at @s if block ~ ~ ~ lightning_rod[facing=south] if block ~ ~ ~1 #copperwire:chiseled_coppers run summon marker ~ ~ ~1 {Tags:["copper_wire","passthrough_wire_block"]}
execute as @s[type=marker] at @s if block ~ ~ ~ lightning_rod[facing=up] if block ~ ~1 ~ #copperwire:chiseled_coppers run summon marker ~ ~1 ~ {Tags:["copper_wire","passthrough_wire_block"]}
execute as @s[type=marker] at @s if block ~ ~ ~ lightning_rod[facing=down] if block ~ ~-1 ~ #copperwire:chiseled_coppers run summon marker ~ ~-1 ~ {Tags:["copper_wire","passthrough_wire_block"]}

# Chain activation
execute as @s[type=marker,tag=transformer_chain] at @s if block ~ ~ ~ chain[axis=x] if block ~1 ~ ~ #copperwire:copper_bulbs[powered=true] if block ~-1 ~ ~ lightning_rod[facing=west] run summon marker ~-1 ~ ~ {Tags:["copper_wire"]}
execute as @s[type=marker,tag=transformer_chain] at @s if block ~ ~ ~ chain[axis=x] if block ~-1 ~ ~ #copperwire:copper_bulbs[powered=true] if block ~1 ~ ~ lightning_rod[facing=east] run summon marker ~1 ~ ~ {Tags:["copper_wire"]}
execute as @s[type=marker,tag=transformer_chain] at @s if block ~ ~ ~ chain[axis=z] if block ~ ~ ~1 #copperwire:copper_bulbs[powered=true] if block ~ ~ ~-1 lightning_rod[facing=north] run summon marker ~ ~ ~-1 {Tags:["copper_wire"]}
execute as @s[type=marker,tag=transformer_chain] at @s if block ~ ~ ~ chain[axis=z] if block ~ ~ ~-1 #copperwire:copper_bulbs[powered=true] if block ~ ~ ~1 lightning_rod[facing=south] run summon marker ~ ~ ~1 {Tags:["copper_wire"]}
execute as @s[type=marker,tag=transformer_chain] at @s if block ~ ~ ~ chain[axis=y] if block ~ ~1 ~ #copperwire:copper_bulbs[powered=true] if block ~ ~-1 ~ lightning_rod[facing=down] run summon marker ~ ~-1 ~ {Tags:["copper_wire"]}
execute as @s[type=marker,tag=transformer_chain] at @s if block ~ ~ ~ chain[axis=y] if block ~ ~-1 ~ #copperwire:copper_bulbs[powered=true] if block ~ ~1 ~ lightning_rod[facing=up] run summon marker ~ ~1 ~ {Tags:["copper_wire"]}

# Capacitor activation
execute as @s[type=marker] at @s if block ~ ~ ~ lightning_rod[facing=up] positioned ~ ~1 ~ if block ~ ~ ~ heavy_core unless entity @e[type=text_display,tag=capacitor_text_display,distance=...001] run summon text_display ~ ~ ~ {Tags:["capacitor_text_display"],billboard:"center",text:'{"color":"light_purple","score":{"name":"@s","objective":"Capacitor_Charge"}}',transformation:{left_rotation:[0f,0f,0f,1f],right_rotation:[0f,0f,0f,1f],translation:[0f,.25f,0f],scale:[1f,1f,1f]}}
execute as @s[type=marker,tag=!up] at @s if block ~ ~ ~ #copperwire:grates_and_chiseled positioned ~ ~1 ~ if block ~ ~ ~ heavy_core unless entity @e[type=text_display,tag=capacitor_text_display,distance=...001] run summon text_display ~ ~ ~ {Tags:["capacitor_text_display"],billboard:"center",text:'{"color":"light_purple","score":{"name":"@s","objective":"Capacitor_Charge"}}',transformation:{left_rotation:[0f,0f,0f,1f],right_rotation:[0f,0f,0f,1f],translation:[0f,.25f,0f],scale:[1f,1f,1f]}}
execute as @s[type=marker,tag=!up] at @s if block ~ ~ ~ #copperwire:grates_and_chiseled if block ~ ~1 ~ heavy_core run tag @s add up

# Block to Wire activation and directional tagging
execute as @s[type=marker,tag=!east] at @s if block ~ ~ ~ #copperwire:grates_and_chiseled if block ~1 ~ ~ lightning_rod[facing=east,powered=false] run summon marker ~1 ~ ~ {Tags:["copper_wire"]}
execute as @s[type=marker,tag=!west] at @s if block ~ ~ ~ #copperwire:grates_and_chiseled if block ~-1 ~ ~ lightning_rod[facing=west,powered=false] run summon marker ~-1 ~ ~ {Tags:["copper_wire"]}
execute as @s[type=marker,tag=!north] at @s if block ~ ~ ~ #copperwire:grates_and_chiseled if block ~ ~ ~-1 lightning_rod[facing=north,powered=false] run summon marker ~ ~ ~-1 {Tags:["copper_wire"]}
execute as @s[type=marker,tag=!south] at @s if block ~ ~ ~ #copperwire:grates_and_chiseled if block ~ ~ ~1 lightning_rod[facing=south,powered=false] run summon marker ~ ~ ~1 {Tags:["copper_wire"]}
execute as @s[type=marker,tag=!up] at @s if block ~ ~ ~ #copperwire:grates_and_chiseled if block ~ ~1 ~ lightning_rod[facing=up,powered=false] run summon marker ~ ~1 ~ {Tags:["copper_wire"]}
execute as @s[type=marker,tag=!down] at @s if block ~ ~ ~ #copperwire:grates_and_chiseled if block ~ ~-1 ~ lightning_rod[facing=down,powered=false] run summon marker ~ ~-1 ~ {Tags:["copper_wire"]}
execute as @s[type=marker,tag=!east] at @s if block ~ ~ ~ #copperwire:grates_and_chiseled if block ~1 ~ ~ lightning_rod[facing=east,powered=false] run tag @s add east
execute as @s[type=marker,tag=!west] at @s if block ~ ~ ~ #copperwire:grates_and_chiseled if block ~-1 ~ ~ lightning_rod[facing=west,powered=false] run tag @s add west
execute as @s[type=marker,tag=!north] at @s if block ~ ~ ~ #copperwire:grates_and_chiseled if block ~ ~ ~-1 lightning_rod[facing=north,powered=false] run tag @s add north
execute as @s[type=marker,tag=!south] at @s if block ~ ~ ~ #copperwire:grates_and_chiseled if block ~ ~ ~1 lightning_rod[facing=south,powered=false] run tag @s add south
execute as @s[type=marker,tag=!up] at @s if block ~ ~ ~ #copperwire:grates_and_chiseled if block ~ ~1 ~ lightning_rod[facing=up,powered=false] run tag @s add up
execute as @s[type=marker,tag=!down] at @s if block ~ ~ ~ #copperwire:grates_and_chiseled if block ~ ~-1 ~ lightning_rod[facing=down,powered=false] run tag @s add down

